Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/Makefile.deps
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/Makefile.deps	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/Makefile.deps	(revision 88)
@@ -0,0 +1,38 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+# DIR_MORPHEO must be defined
+
+Front_end_Glue			= yes
+
+ifndef Behavioural
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.deps
+endif
+
+#-----[ Directory ]----------------------------------------
+
+Front_end_Glue_DIR			=	$(DIR_MORPHEO)/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue
+
+#-----[ Library ]------------------------------------------
+
+Front_end_Glue_LIBRARY		= 	-lFront_end_Glue	\
+					$(Behavioural_LIBRARY)	
+
+Front_end_Glue_DIR_LIBRARY		=	-L$(Front_end_Glue_DIR)/lib	\
+					$(Behavioural_DIR_LIBRARY)
+
+#-----[ Rules ]--------------------------------------------
+
+Front_end_Glue_library		:
+				@\
+				$(MAKE) Behavioural_library;		\
+				$(MAKE) --directory=$(Front_end_Glue_DIR) --makefile=Makefile;
+
+Front_end_Glue_library_clean	:
+				@\
+				$(MAKE) Behavioural_library_clean;	\
+				$(MAKE) --directory=$(Front_end_Glue_DIR) --makefile=Makefile clean;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/Makefile	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/Makefile	(revision 88)
@@ -0,0 +1,32 @@
+# 
+# $Id$
+# 
+# [ Description ]
+# 
+# Makefile
+# 
+
+#-----[ Directory ]----------------------------------------
+DIR_COMPONENT			= ../
+include				$(DIR_COMPONENT)/Makefile.defs
+
+LIBRARY				= $(Front_end_Glue_LIBRARY)
+
+DIR_LIBRARY			= $(Front_end_Glue_DIR_LIBRARY)
+
+#-----[ include ]------------------------------------------
+
+all				:
+				@$(MAKE) all_selftest
+
+library				: Front_end_Glue_library
+
+library_clean			: Front_end_Glue_library_clean
+
+local_clean			:
+
+include                         $(DIR_COMPONENT)/Makefile.deps
+include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Common
+include				$(DIR_MORPHEO)/Behavioural/Makefile.Selftest
+include 			$(DIR_MORPHEO)/Behavioural/Makefile.Synthesis
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-context_1-decod_unit_1.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-context_1-decod_unit_1.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-context_1-decod_unit_1.cfg	(revision 88)
@@ -0,0 +1,9 @@
+Front_end_Glue
+1	1	+1	# nb_context                     
+1	1	+1	# nb_decod_unit                  
+1	1	+1	# nb_inst_decod              [0] [nb_decod_unit]
+1	1	+1	# nb_inst_branch_complete        
+0	0	+1	# link_context_to_decod_unit [0] [nb_context]
+30	30	+1	# size_address                   
+2	2	+1	# size_depth                 [0] [nb_context]
+4	4	+1	# nb_branch_speculated       [0] [nb_context]
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-context_4-decod_unit_1.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-context_4-decod_unit_1.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-context_4-decod_unit_1.cfg	(revision 88)
@@ -0,0 +1,18 @@
+Front_end_Glue
+4	4	+1	# nb_context                     
+1	1	+1	# nb_decod_unit                  
+1	1	+1	# nb_inst_decod              [0] [nb_decod_unit]
+1	1	+1	# nb_inst_branch_complete        
+0	0	+1	# link_context_to_decod_unit [0] [nb_context]
+0	0	+1	# link_context_to_decod_unit [1] [nb_context]
+0	0	+1	# link_context_to_decod_unit [2] [nb_context]
+0	0	+1	# link_context_to_decod_unit [3] [nb_context]
+30	30	+1	# size_address                   
+2	2	+1	# size_depth                 [0] [nb_context]
+0	0	+1	# size_depth                 [1] [nb_context]
+1	1	+1	# size_depth                 [2] [nb_context]
+3	3	+1	# size_depth                 [3] [nb_context]
+4	4	+1	# nb_branch_speculated       [0] [nb_context]
+1	1	+1	# nb_branch_speculated       [1] [nb_context]
+2	2	+1	# nb_branch_speculated       [2] [nb_context]
+8	8	+1	# nb_branch_speculated       [3] [nb_context]
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-context_4-decod_unit_2-a.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-context_4-decod_unit_2-a.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-context_4-decod_unit_2-a.cfg	(revision 88)
@@ -0,0 +1,19 @@
+Front_end_Glue
+4	4	+1	# nb_context                     
+2	2	+1	# nb_decod_unit                  
+4	4	+1	# nb_inst_decod              [0] [nb_decod_unit]
+1	1	+1	# nb_inst_decod              [1] [nb_decod_unit]
+1	1	+1	# nb_inst_branch_complete        
+0	0	+1	# link_context_to_decod_unit [0] [nb_context]
+1	1	+1	# link_context_to_decod_unit [1] [nb_context]
+0	0	+1	# link_context_to_decod_unit [2] [nb_context]
+1	1	+1	# link_context_to_decod_unit [3] [nb_context]
+30	30	+1	# size_address                   
+2	2	+1	# size_depth                 [0] [nb_context]
+0	0	+1	# size_depth                 [1] [nb_context]
+1	1	+1	# size_depth                 [2] [nb_context]
+3	3	+1	# size_depth                 [3] [nb_context]
+4	4	+1	# nb_branch_speculated       [0] [nb_context]
+1	1	+1	# nb_branch_speculated       [1] [nb_context]
+2	2	+1	# nb_branch_speculated       [2] [nb_context]
+8	8	+1	# nb_branch_speculated       [3] [nb_context]
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-context_4-decod_unit_2-b.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-context_4-decod_unit_2-b.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-context_4-decod_unit_2-b.cfg	(revision 88)
@@ -0,0 +1,19 @@
+Front_end_Glue
+4	4	+1	# nb_context                     
+2	2	+1	# nb_decod_unit                  
+4	4	+1	# nb_inst_decod              [0] [nb_decod_unit]
+1	1	+1	# nb_inst_decod              [1] [nb_decod_unit]
+1	1	+1	# nb_inst_branch_complete        
+0	0	+1	# link_context_to_decod_unit [0] [nb_context]
+1	1	+1	# link_context_to_decod_unit [1] [nb_context]
+1	1	+1	# link_context_to_decod_unit [2] [nb_context]
+1	1	+1	# link_context_to_decod_unit [3] [nb_context]
+30	30	+1	# size_address                   
+2	2	+1	# size_depth                 [0] [nb_context]
+0	0	+1	# size_depth                 [1] [nb_context]
+1	1	+1	# size_depth                 [2] [nb_context]
+3	3	+1	# size_depth                 [3] [nb_context]
+4	4	+1	# nb_branch_speculated       [0] [nb_context]
+1	1	+1	# nb_branch_speculated       [1] [nb_context]
+2	2	+1	# nb_branch_speculated       [2] [nb_context]
+8	8	+1	# nb_branch_speculated       [3] [nb_context]
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-context_4-decod_unit_4.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-context_4-decod_unit_4.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-context_4-decod_unit_4.cfg	(revision 88)
@@ -0,0 +1,21 @@
+Front_end_Glue
+4	4	+1	# nb_context                     
+4	4	+1	# nb_decod_unit                  
+2	2	+1	# nb_inst_decod              [0] [nb_decod_unit]
+4	4	+1	# nb_inst_decod              [1] [nb_decod_unit]
+1	1	+1	# nb_inst_decod              [2] [nb_decod_unit]
+8	8	+1	# nb_inst_decod              [3] [nb_decod_unit]
+1	1	+1	# nb_inst_branch_complete        
+1	1	+1	# link_context_to_decod_unit [0] [nb_context]
+0	0	+1	# link_context_to_decod_unit [1] [nb_context]
+3	3	+1	# link_context_to_decod_unit [2] [nb_context]
+2	2	+1	# link_context_to_decod_unit [3] [nb_context]
+30	30	+1	# size_address                   
+2	2	+1	# size_depth                 [0] [nb_context]
+0	0	+1	# size_depth                 [1] [nb_context]
+1	1	+1	# size_depth                 [2] [nb_context]
+3	3	+1	# size_depth                 [3] [nb_context]
+4	4	+1	# nb_branch_speculated       [0] [nb_context]
+1	1	+1	# nb_branch_speculated       [1] [nb_context]
+2	2	+1	# nb_branch_speculated       [2] [nb_context]
+8	8	+1	# nb_branch_speculated       [3] [nb_context]
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-min.cfg
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-min.cfg	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/config-min.cfg	(revision 88)
@@ -0,0 +1,9 @@
+Front_end_Glue
+1	1	+1	# nb_context                     
+1	1	+1	# nb_decod_unit                  
+1	1	+1	# nb_inst_decod              [0] [nb_decod_unit]
+1	1	+1	# nb_inst_branch_complete        
+0	0	+1	# link_context_to_decod_unit [0] [nb_context]
+30	30	+1	# size_address                   
+0	0	+1	# size_depth                 [0] [nb_context]
+1	1	+1	# nb_branch_speculated       [0] [nb_context]
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/include/test.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/include/test.h	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/include/test.h	(revision 88)
@@ -0,0 +1,30 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ * Test "RegisterFile"
+ */
+
+#ifdef SYSTEMC
+#include "systemc.h"
+#endif
+
+#define NB_ITERATION  1
+#define CYCLE_MAX     (1024*NB_ITERATION)
+
+#include "Common/include/Test.h"
+#include "Common/include/Time.h"
+#include "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/include/Front_end_Glue.h"
+
+using namespace std;
+using namespace morpheo;
+using namespace morpheo::behavioural;
+using namespace morpheo::behavioural::core;
+using namespace morpheo::behavioural::core::multi_front_end;
+using namespace morpheo::behavioural::core::multi_front_end::front_end;
+
+using namespace morpheo::behavioural::core::multi_front_end::front_end::front_end_glue;
+
+void test    (string name,
+	      morpheo::behavioural::core::multi_front_end::front_end::front_end_glue::Parameters * param);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/src/main.cpp	(revision 88)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/src/main.cpp	(revision 88)
@@ -0,0 +1,120 @@
+/*
+ * $Id$
+ *
+ * [ Description ]
+ * 
+ */
+
+#include "Behavioural/Core/Multi_Front_end/Front_end/Front_end_Glue/SelfTest/include/test.h"
+
+#define NB_PARAMS 4
+
+void usage (int argc, char * argv[])
+{
+  err (_("<Usage> %s name_instance list_params.\n"),argv[0]);
+  err (_("list_params is :\n"));
+  err (_(" * nb_context                                 (uint32_t)\n"));
+  err (_(" * nb_decod_unit                              (uint32_t)\n"));
+  err (_(" * nb_inst_decod              [nb_decod_unit] (uint32_t)\n"));
+  err (_(" * nb_inst_branch_complete                    (uint32_t)\n"));
+  err (_(" * link_context_to_decod_unit [nb_context]    (uint32_t)\n"));
+  err (_(" * size_address                               (uint32_t)\n"));
+  err (_(" * size_depth                 [nb_context]    (uint32_t)\n"));
+  err (_(" * nb_branch_speculated       [nb_context]    (uint32_t)\n"));
+
+  exit (1);
+}
+
+#ifndef SYSTEMC
+int main    (int argc, char * argv[])
+#else
+int sc_main (int argc, char * argv[])
+#endif
+{
+  for (int32_t i=0; i<argc; ++i)
+    msg("%s ",argv[i]);
+  msg("\n");
+
+  if (argc <= static_cast<int>(2+NB_PARAMS))
+    usage (argc, argv);
+
+  uint32_t x = 1;
+
+  string name = argv[x++];
+
+  uint32_t   _nb_context                 = fromString<uint32_t>(argv[x++]);
+  uint32_t   _nb_decod_unit              = fromString<uint32_t>(argv[x++]);
+  
+  if (argc != static_cast<int>(2+NB_PARAMS+3*_nb_context+1*_nb_decod_unit))
+    usage (argc, argv);
+
+  uint32_t * _nb_inst_decod              = new uint32_t [_nb_decod_unit];
+  for (uint32_t i=0; i<_nb_decod_unit; ++i)
+    _nb_inst_decod [i] = fromString<uint32_t>(argv[x++]);
+
+  uint32_t   _nb_inst_branch_complete    = fromString<uint32_t>(argv[x++]);
+
+  uint32_t * _link_context_to_decod_unit = new uint32_t [_nb_context];
+  for (uint32_t i=0; i<_nb_context; ++i)
+    _link_context_to_decod_unit [i] = fromString<uint32_t>(argv[x++]);
+
+  uint32_t   _size_address               = fromString<uint32_t>(argv[x++]);
+
+  uint32_t * _size_depth                 = new uint32_t [_nb_context];
+  for (uint32_t i=0; i<_nb_context; ++i)
+    _size_depth [i] = fromString<uint32_t>(argv[x++]);
+
+  uint32_t * _nb_branch_speculated       = new uint32_t [_nb_context];
+  for (uint32_t i=0; i<_nb_context; ++i)
+    _nb_branch_speculated [i] = fromString<uint32_t>(argv[x++]);
+
+  std::vector<uint32_t> * _translate_context_id_from_decod_unit = new std::vector<uint32_t> [_nb_decod_unit];
+
+  for (uint32_t i=0; i<_nb_context; ++i)
+    _translate_context_id_from_decod_unit [_link_context_to_decod_unit[i]].push_back(i);
+
+  int _return = EXIT_SUCCESS;
+  try 
+    {
+      morpheo::behavioural::core::multi_front_end::front_end::front_end_glue::Parameters * param = new morpheo::behavioural::core::multi_front_end::front_end::front_end_glue::Parameters
+	(_nb_context                           ,
+         _nb_decod_unit                        ,
+         _nb_inst_decod                        ,
+         _nb_inst_branch_complete              ,
+         _link_context_to_decod_unit           ,
+         _translate_context_id_from_decod_unit ,
+         _size_address                         ,
+         _size_depth                           ,
+         _nb_branch_speculated                 ,
+         true // is_toplevel
+        );
+      
+      test (name,param);
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+      msg (_("%s"),error.what ());
+      _return = EXIT_FAILURE;
+    }
+  
+  try 
+    {
+      if (_return == EXIT_SUCCESS)
+	TEST_OK("Front_end_Glue : no error");
+      else
+	TEST_KO("Front_end_Glue : a lot of error");
+    }
+  catch (morpheo::ErrorMorpheo & error)
+    {
+//       msg (_("<%s> :\n%s"),name.c_str(), error.what ());
+      _return = EXIT_FAILURE;
+    }
+
+  delete [] _translate_context_id_from_decod_unit;
+  delete [] _nb_branch_speculated       ;
+  delete [] _size_depth                 ;
+  delete [] _link_context_to_decod_unit ;
+  delete [] _nb_inst_decod              ;
+
+  return (_return);
+}
